package com.icontrols.kakao.utils;

import java.io.UnsupportedEncodingException;
import java.security.GeneralSecurityException;
import java.util.Base64;
import java.util.Date;
import java.util.Base64.Decoder;

import org.json.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class JWTUtils {
	private static final Logger logger = LoggerFactory.getLogger(JWTUtils.class);

	public JWTUtils() {
		super();
	}

	public String getCmpIpFromToken(String token) {

		Decoder decoder = Base64.getDecoder();
		String enPayload = token.split("\\.")[1];
		String dePayload = new String(decoder.decode(enPayload));
		logger.info("P= " + enPayload);
		JSONObject obj = new JSONObject(dePayload);

		String cmpIp = obj.get("cmpIp").toString();
		Decoder dcoder = Base64.getDecoder();
		cmpIp = new String(decoder.decode(cmpIp));

		return cmpIp;
	}

//	public boolean validateToken(String token, String type) throws UnsupportedEncodingException {
//
//		String secretKey = "";
//		if (type.equals("accessToken")) {
//			secretKey = CONSTANTS.ACCESS_TOEKN_SECRET_KEY;
//		} else if (type.equals("refreshToken")) {
//			secretKey = CONSTANTS.REFRESH_TOKEN_SECRET_KEY;
//		}
//		logger.info(token);
//		Decoder decoder = Base64.getDecoder();
//		// 시그니처가 맞는지 확인
//		String enHeader = token.split("\\.")[0];
//		logger.info("H= " + enHeader);
//		String enPayload = token.split("\\.")[1];
//		String dePayload = new String(decoder.decode(enPayload));
//		logger.info("P= " + enPayload);
//		String signiture = token.split("\\.")[2];
//		logger.info("S= " + signiture);
//		JSONObject obj = new JSONObject(dePayload);
//
//		String jwt = Jwts.builder().setExpiration(new Date(3600000)) // 1시간 -> 설정정보로 변경해야함
//				.claim("cmpIp", obj.get("cmpIp")).claim("homeId", obj.get("homeId")).claim("iat", obj.get("iat"))
//				.signWith(SignatureAlgorithm.HS256, secretKey.getBytes("UTF-8")).compact();
//		logger.info("new = " + jwt);
//		if (token.equals(jwt)) {
//			long iat = Long.parseLong(obj.get("iat").toString());
//			long currentTime = System.currentTimeMillis() / 1000;
//			if (currentTime > iat + Long.parseLong(obj.get("exp").toString())) {
//				return false;
//			}
//			return true;
//		}
//		return false;
//
//	}
//
//	public String getHomeIdFromToken(String token)
//			throws UnsupportedEncodingException, NoSuchAlgorithmException, GeneralSecurityException {
//
//		Decoder decoder = Base64.getDecoder();
//		String enPayload = token.split("\\.")[1];
//		String dePayload = new String(decoder.decode(enPayload));
//		JSONObject obj = new JSONObject(dePayload);
//
//		String encodedHomeId = obj.get("homeId").toString();
//		AES256Util aes = new AES256Util();
//		String homeId = aes.decrypt(encodedHomeId);
//
//		return homeId;
//	}

}
